## P/S/K PBL Trainer
## 17 April 2021

# IMPORTS

import random
import keyboard
import time

# LISTS/VARIABLES

allAlgs = ["0,-1/3,-3/-3,0/1,1/-1,2/", "1,0/3,-3/0,3/-1,-1/-2,1/",
           "0,-1/1,-2/2,2/0,-3/-3,3/", "1,0/0,-3/2,2/1,-2/-3,3/",
           "0,-1/0,-3/0,3/1,-2/-1,2/", "0,-1/1,-2/-1,2/0,-3/0,3/",
           "1,0/3,0/-3,0/2,-1/-2,1/", "1,0/2,-1/-2,1/3,0/-3,0/",
           "1,0/0,3/0,-3/-1,2/1,-2/", "1,0/-1,2/1,-2/0,3/0,-3/",
           "0,-1/-3,0/3,0/-2,1/2,-1/", "0,-1/-2,1/2,-1/-3,0/3,0/",
           "1,0/0,-3/0,3/2,-1/-2,1/", "1,0/2,-1/-2,1/0,-3/0,3/",
           "0,-1/3,0/-3,0/1,-2/-1,2/", "0,-1/1,-2/-1,2/3,0/-3,0/",
           "1,0/-3,0/3,0/-1,2/1,-2/", "1,0/-1,2/1,-2/-3,0/3,0/",
           "0,-1/0,3/0,-3/-2,1/2,-1/", "0,-1/-2,1/2,-1/0,3/0,-3/"]
SS = [allAlgs[0], allAlgs[1]]
KK = [allAlgs[2], allAlgs[3]]
PS = [allAlgs[4], allAlgs[5], allAlgs[6], allAlgs[7], allAlgs[8], allAlgs[9], allAlgs[10], allAlgs[11]]
PK = [allAlgs[12], allAlgs[13], allAlgs[14], allAlgs[15], allAlgs[16], allAlgs[17], allAlgs[18], allAlgs[19]]
PSandPK = PS + PK
AUDF = ["U ", "U' ", "D ", "D' ", "U D ", "U D' ", "U' D ", "U' D' "]

# PROGRAM

print("""\nWelcome to the P/S/K PBL Trainer. 
You will first be given a list of subsets to choose from.
Once you've chosen an option, press enter to get an algorithm to practice.
When you're comfortable with the algorithm, press enter to move onto the next.

TO CHANGE THE SUBSET OF ALGS: press n.
TO QUIT: press escape.

Here are the options as to what you can practice:
1) All P/S/K algs
2) S/S only
3) K/K only
4) P/S only
5) P/K only
6) P/S and P/K
""")
ValidChoice = False 
while ValidChoice == False:
    UserInput = input("Select an option 1 through 6: ")    
    if UserInput == "1" or UserInput == "2" or UserInput == "3" or UserInput == "4" or UserInput == "5" or UserInput == "6":
        ValidChoice = True
    else: 
        print("Please enter a number 1 through 6! Try again.")

done = False

while done == False:
    if UserInput == "1":
        if keyboard.is_pressed('enter'):
            time.sleep(0.1)
            print("\n" + random.choice(AUDF) + random.choice(allAlgs) + " " + random.choice(AUDF))
        elif keyboard.is_pressed('n'):
            print("""\nHere are the options as to what you can practice:
1) All P/S/K algs
2) S/S only
3) K/K only
4) P/S only
5) P/K only
6) P/S and P/K
""")
            ValidChoice = False 
            while ValidChoice == False:                
                UserInput = input("Select an option 1 through 6: ")    
                if UserInput == "1" or UserInput == "2" or UserInput == "3" or UserInput == "4" or UserInput == "5" or UserInput == "6":
                    ValidChoice = True
                else: 
                    print("Please enter a number 1 through 6! Try again.")
        elif keyboard.is_pressed('esc'):
            done = True
    elif UserInput == "2":
        if keyboard.is_pressed('enter'):
            time.sleep(0.1)
            print("\n" + random.choice(AUDF) + random.choice(SS) + " " + random.choice(AUDF))
        elif keyboard.is_pressed('n'):
            print("""\nHere are the options as to what you can practice:
1) All P/S/K algs
2) S/S only
3) K/K only
4) P/S only
5) P/K only
6) P/S and P/K
""")
            ValidChoice = False 
            while ValidChoice == False:
                UserInput = input("Select an option 1 through 6: ")    
                if UserInput == "1" or UserInput == "2" or UserInput == "3" or UserInput == "4" or UserInput == "5" or UserInput == "6":
                    ValidChoice = True
                else: 
                    print("Please enter a number 1 through 6! Try again.")
        elif keyboard.is_pressed('esc'):
            done = True
    elif UserInput == "3": 
        if keyboard.is_pressed('enter'):
            time.sleep(0.1)
            print("\n" + random.choice(AUDF) + random.choice(KK) + " " + random.choice(AUDF))
        elif keyboard.is_pressed('n'):
            print("""\nHere are the options as to what you can practice:
1) All P/S/K algs
2) S/S only
3) K/K only
4) P/S only
5) P/K only
6) P/S and P/K
""")
            ValidChoice = False 
            while ValidChoice == False:
                UserInput = input("Select an option 1 through 6: ")    
                if UserInput == "1" or UserInput == "2" or UserInput == "3" or UserInput == "4" or UserInput == "5" or UserInput == "6":
                    ValidChoice = True
                else: 
                    print("Please enter a number 1 through 6! Try again.")
        elif keyboard.is_pressed('esc'):
            done = True
    elif UserInput == "4":
        if keyboard.is_pressed('enter'):
            time.sleep(0.1)
            print("\n" + random.choice(AUDF) + random.choice(PS) + " " + random.choice(AUDF))
        elif keyboard.is_pressed('n'):
            print("""\nHere are the options as to what you can practice:
1) All P/S/K algs
2) S/S only
3) K/K only
4) P/S only
5) P/K only
6) P/S and P/K
""")
            ValidChoice = False 
            while ValidChoice == False:
                UserInput = input("Select an option 1 through 6: ")    
                if UserInput == "1" or UserInput == "2" or UserInput == "3" or UserInput == "4" or UserInput == "5" or UserInput == "6":
                    ValidChoice = True
                else: 
                    print("Please enter a number 1 through 6! Try again.")
        elif keyboard.is_pressed('esc'):
            done = True
    elif UserInput == "5": 
        if keyboard.is_pressed('enter'):
            time.sleep(0.1)
            print("\n" + random.choice(AUDF) + random.choice(PK) + " " + random.choice(AUDF))
        elif keyboard.is_pressed('n'):
            print("""\nHere are the options as to what you can practice:
1) All P/S/K algs
2) S/S only
3) K/K only
4) P/S only
5) P/K only
6) P/S and P/K
""")
            ValidChoice = False 
            while ValidChoice == False:
                UserInput = input("Select an option 1 through 6: ")    
                if UserInput == "1" or UserInput == "2" or UserInput == "3" or UserInput == "4" or UserInput == "5" or UserInput == "6":
                    ValidChoice = True
                else: 
                    print("Please enter a number 1 through 6! Try again.")
        elif keyboard.is_pressed('esc'):
            done = True
    elif UserInput == "6": 
        if keyboard.is_pressed('enter'):
            time.sleep(0.1)
            print("\n" + random.choice(AUDF) + random.choice(PSandPK) + " " + random.choice(AUDF))
        elif keyboard.is_pressed('n'):
            print("""\nHere are the options as to what you can practice:
1) All P/S/K algs
2) S/S only
3) K/K only
4) P/S only
5) P/K only
6) P/S and P/K
""")
            ValidChoice = False 
            while ValidChoice == False:
                UserInput = input("Select an option 1 through 6: ")    
                if UserInput == "1" or UserInput == "2" or UserInput == "3" or UserInput == "4" or UserInput == "5" or UserInput == "6":
                    ValidChoice = True
                else: 
                    print("Please enter a number 1 through 6! Try again.")
        elif keyboard.is_pressed('esc'):
            done = True